= Changelog
ifdef::env-github[:outfilesuffix: .adoc]

All notable changes to this project will be documented in this file.

The format is based on http://keepachangelog.com/en/1.0.0/[Keep a Changelog]
and this project adheres to http://semver.org/spec/v2.0.0.html[Semantic Versioning].

<!-- == https://github.com/robotframework/RIDE[Unreleased] -->

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.1.2.rst[2.1.2] - 2025-01-28

=== Fixed

- Partial fix of no update of renaming resource prefixed keywords. Issue #1230 from 29 Jan 2013.
- Fixed no recognition of keywords with embedded arguments and full name. Issue #1106 from 12 Sep 2012.

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.1.1.rst[2.1.1] - 2024-11-14

=== Changed

- Changed the workflow for the development versions of RIDE. Now, development versions are taken from the ``develop`` branch, and the ``master`` will stay with released version.
- Changed the way ``configobj`` code is imported. Now is a submodule obtained from https://github.com/DiffSK/configobj.

=== Fixed

- Fixed broken go to definition after editing content in resource files.

- Fixed long arguments in fixtures appearing splitted in Grid Editor. Still, arguments info will not be correct at calling step.

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.1.rst[2.1] - 2024-10-13

=== Added
  (2.1 - 2024-10-13)
- Added a setting for a specific Browser by editing the settings.cfg file. Add the string parameter
``browser`` in the section ``[Plugins][[Test Runner]]``.
  (2.1b1 - 2024-09-21)
- Added color to Test Runner Console Log final output, report and log since RF v7.1rc1.
- Added Korean language support for UI, experimental.
- Added option ``caret style`` to change insert caret to `block` or `line` in Text Editor, by editing ``settings.cfg``.
The color of the caret is the same as `setting` and will be adjusted for better contrast with the background.
  (2.1a3 - 2024-07-22)
- Added support for Setup in keywords, since Robot Framework version 7.0.
- Added support for new VAR marker, since Robot Framework version 7.0.
- Added configurable style of the tabs in notebook pages, Edit, Text, Run, etc. Parameter ``notebook theme``
takes values from 0 to 5. See wxPython, demo for agw.aui for details.
- Added UI localization and support for Japanese configured test suites, valid for Robot Framework version 7.0.1 or higher.
- Added to Grid Editor, changing Zoom In/Out with ``Ctrl-Mouse Wheel`` and setting at Preferences.
- Added actions on columns of Grid Editor: Double-Click or Right Mouse Click, allows to edit the column name for Data
Driven or Templated; Left Mouse Click, selects the column cells.
- Added command line option, ``--settingspath``, to select a different configuration. For example, you can have different
colour settings or UI language.
- Added different settings file, according the actual Python executable, if not the original installed.
This allows different configurations, like, for example, in a virtual environment
- Added context option ``Open Containing Folder`` to test suites directories in Project Explorer.
- Added a setting for a specific file manager by editing the settings.cfg file. Add the string parameter ``file manager`` in the section ``[General]``.
- Added minimal support to have comment lines in Import settings. These are not supposed to be edited in Editor, and new lines are added at Text Editor.
- Added a selector for Tasks and Language to the New Project dialog. Still some problems: Tasks type changes to Tests,
localized sections only stay translated after Apply in Text Editor.
- Added UI localization prepared for all the languages from installed Robot Framework version 6.1, or
higher. Major translations are: Dutch, Portuguese and Brazilian Portuguese. Language is selected from
Tools->Preferences->General.
- Added support for language configured test suites, with installed Robot Framework version 6.1 or higher.
- Fields are shown in the language of the files in Grid Editor (will be configurable in future versions).
- Tooltips for the fields are always shown in English.
- Colorization for language configured files is working in Text Editor.
  (2.0.8.1 - 2023-11-01)
- Added auto update check when development version is installed
- Added menu option ``Help->Check for Upgrade`` which allows to force update check and install development version
- Added ``Upgrade Now`` action to update dialog.
- Added Test Tags field (new, since Robot Framework 6.0) to Test Suites settings. This field will replace Default and
Force Tags settings, after Robot Framework 7.0
- Added content help pop-up on Text Editor by pressing ``Ctrl`` for text at cursor position or selected autocomplete list item
- Added Exclude option in context nenu for Test files, previously was only possible for Test Suites folders
- Added exclusion of monitoring filesystem changes for files and directories excluded in Preferences
- Added variables creation shortcuts (``Ctrl-1,2,5``) to fields Arguments in Grid Editor
- Added support for JSON variables, by using the installed Robot Framework import method
  (2.0.7 - 2023-08-13)
- Added indication of matching brackets, ``()``, ``{}``, ``[]``, in Text Editor
- Added context menu to RIDE tray icon. Options Show, Hide and Close
- Added sincronization with Project Explorer to navigate to selected item, Test Case, Keyword, Variable, in Text Editor
  Note: This feature is working fine in Fedora 38, but not on Windows and macOS.
  (2.0.6 - 2023-06-10)
- Added boolean parameter ``filter newlines`` to Grid Editor with default ``True``, to hide or show newlines in cells
  (2.0.5 - 2023-05-08)
- Added ``FOR`` scope markers (``IN``, ``IN RANGE``, ``IN ENUMERATE``, ``IN ZIP``) to auto-complete list
- Added support to read environment variable ``ROBOT_VERSION`` to apply some conditions.
- Added note on Test Timeout that **timeout message** is not supported since Robot v3.0.1
- Added the note, 'Colors will be active after next RIDE restart.' to the Preferences of Test Runner.

=== Changed
  (2.1 - 2024-10-13)
- Changed the order of insert and delete rows in Grid Editor rows context menu.
  (2.1b1 - 2024-09-21)
- Allow to do auto-suggestions of keywords in Text Editor without a shortcut, if you want to enable or disable this feature you can config in `Tools -> Preferences -> Text Editor -> Enable auto suggestions`.
  (2.1a3 - 2024-07-22)
- Improved release packaging of RIDE, by using entry_points in setuptools configuration.
- Parsing of clipboard content to separate by cells in Grid Editor. NOTE: Need to Apply Changes in Text Editor to be effective.
- Improved selection of items from Tree in Text Editor. Now finds more items and selects whole line.
- Changed output in plugin Run Anything (Macros) to allow Zoom In/Out, and Copy content.
  (2.0.8.1 - 2023-11-01)
- Improved keywords documentation search, by adding current dir to search
- Improved Move up/down, ``Alt-UpArrow``/``Alt-DownArrow`` in Text Editor, to have proper indentation and selection
- Improved **RIDE Log** and **Parser Log** windows to allow Zoom In/Out with ``Ctrl-Mouse Wheel``
- Hide continuation markers in Project Tree
- Improved content assistance in Text Editor by allowing to filter list as we type
- Improved file changes detection to only consider valid formats
- Improved keyword ``Find Usages`` to return more matches. Fails to find mixed spaces and ``_``
- In Grid Editor ``Ctrl-Shift-4`` now replaces escaped spaces ``\\ `` by spaces
  (2.0.7 - 2023-08-13)
- Improve Text Editor auto-suggestions to keep libraries prefixes.
  (2.0.6 - 2023-06-10)
- Changed ``tasks.py`` to test ``utest/application/test_app_main.py`` isolated from the other tests
- Improve auto-suggestions of keywords in Grid Editor by allowing to close suggestions list with keys ARROW_LEFT or ARROW_RIGHT
- Improve Text Editor auto-suggestions by using: selected text, text at left or at right of cursor
- Changed ``tasks.py`` to test ``utest/application/test_app_main.py`` isolated from the other tests
- Improve auto-suggestions of keywords in Grid Editor by allowing to close suggestions list with keys ARROW_LEFT or ARROW_RIGHT
- Improve Text Editor auto-suggestions by using: selected text, text at left or at right of cursor
  (2.0.5 - 2023-05-08)
- Changed alias marker on library imports to consider variable ``ROBOT_VERSION``. If version is lower than 6.0, uses ``'WITH NAME'``, otherwise will use ``'AS'``
  (2.0.3 - 2023-04-16)
- Allow to do auto-suggestions of keywords in Grid Editor without a shortcut, if you want to enable or disable this feature you can config in `Tools-> Preferences -> Grid Editor -> Enable auto suggestions`
- Made ``\\n`` visible when editing cells in Grid Editor (problematic in Windows)

=== Fixed
  (2.1 - 2024-10-13)
- Fixed recognition of variables imported from YAML, JSON and Python files.
  (2.1b1 - 2024-09-21)
- Fixed validation of multiple arguments with default values in Grid Editor.
- Fixed on Text Editor when Saving the selection of tests to run in Test Suites (Tree) is cleared.
- Fixed wrong item selection, like Test Suite, when doing right-click actions in Project Explorer.
- Fixed delete variable from Test Suite settings remaining in Project Explorer.
- Fixed obsfuscation of Libraries and Metadata panels when expanding Settings in Grid Editor and Linux systems.- Fixed validation of multiple arguments with default values in Grid Editor.
- Fixed on Text Editor when Saving the selection of tests to run in Test Suites (Tree) is cleared.
- Fixed wrong item selection, like Test Suite, when doing right-click actions in Project Explorer.
- Fixed delete variable from Test Suite settings remaining in Project Explorer.
- Fixed obsfuscation of Libraries and Metadata panels when expanding Settings in Grid Editor and Linux systems.
  (2.1a3 - 2024-07-22)
- Fixed multiline variables in Variables section. In Text Editor they are separated by ... continuation marker.
In Grid Editor use | (pipe) to separate lines.
- Fixed keywords Find Usages in Grid Editor not finding certain values when using Gherkin.
- Fixed plugin Run Anything (Macros) not showing output and broken actions.
- Fixed headers and blank spacing in Templated tests
- Fixed removal of continuation marker in steps
- Fixed wrong continuation of long chains of keywords in Setups, Teardowns or Documentation
- Fixed New User Keyword dialog not allowing empty Arguments field
  (2.0.8.1 - 2023-11-01)
- Fixed escaped spaces showing in Text Editor on commented cells
- Fixed resource files dissapearing from Project tree on Windows
- Fixed missing indication of link for User Keyword, when pressing ``Ctrl`` in Grid Editor
- Fixed exception when finding GREY color for excluded files and directories in Project Tree
- Colorization of Grid Editor cells after the continuation marker ``...`` and correct parsing of those lines
- Colorization of Grid Editor cells when contents is list or dictionary variables
- Validation of Grid Editor arguments types in keywords definitions. Now accepts ``@{}`` named-only marker
- Position of cursor in Text Editor auto-suggestions when line contains multibyte characters
- Drag and drop of variables defined with comments between resource files
  (2.0.7 - 2023-08-13)
- Fixed non syncronized expanding/collapse of Settings panel in Grid Editor, on Linux
- Fixed not working the deletion of cells commented with ``\# `` in Grid Editor with ``Ctrl-Shift-D``
- Fixed empty line being always added to the Variables section in Text Editor
- Fixed wrong project reloading when file system changes detected, and other related problems
- Fixed control commands (``FOR``, ``IF``, ``TRY``, etc) being colorized as valid keywords when typed not in all caps in Grid Editor
- Fixed title of User Keyword in Grid Editor always showing ``Find Usages`` instead of the keyword name
- Fixed renaming keywords when they were arguments of ``Run Keywords`` in Setups and Teardowns
  (2.0.5 - 2023-05-08)
- Fixed auto-indent on block commands in Text Editor
  (2.0.3 - 2023-04-16)
- Fixed missing auto-enclosing when in Cell Editor in Linux
- Fixed RIDE will crash when using third party input method in Mac OS
- Fixed missing color definition for keyword call in Text Editor
- Fixed clearing or emptying fixtures (Setups, Teardowns), now removes headers and synchronizes Text Editor
- Fixed selection and persistance of colors in File Explorer and Project Tree panels
- Fixed not using defined color for help and HTML content
- Fixed missing newlines in sections separation

=== Removed
  (2.1a3 - 2024-07-22)
- Removed support for HTML file format (obsolete since Robot Framework 3.2)
- Removed support for old Python versions, 3.6 nd 3.7.

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.1b1.rst[2.1b1] - 2024-09-21

=== Added

- Added color to Test Runner Console Log final output, report and log since RF v7.1rc1.
- Added Korean language support for UI, experimental.
- Added option ``caret style`` to change insert caret to `block` or `line` in Text Editor, by editing ``settings.cfg``.
The color of the caret is the same as `setting` and will be adjusted for better contrast with the background.

=== Changed

- Allow to do auto-suggestions of keywords in Text Editor without a shortcut, if you want to enable or disable this feature you can config in `Tools -> Preferences -> Text Editor -> Enable auto suggestions`.

=== Fixed

- Fixed validation of multiple arguments with default values in Grid Editor.
- Fixed on Text Editor when Saving the selection of tests to run in Test Suites (Tree) is cleared.
- Fixed wrong item selection, like Test Suite, when doing right-click actions in Project Explorer.
- Fixed delete variable from Test Suite settings remaining in Project Explorer.
- Fixed obsfuscation of Libraries and Metadata panels when expanding Settings in Grid Editor and Linux systems.

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.1a3.rst[2.1a3] - 2024-07-22

=== Added

- Added support for Setup in keywords, since Robot Framework version 7.0.
- Added support for new VAR marker, since Robot Framework version 7.0.
- Added configurable style of the tabs in notebook pages, Edit, Text, Run, etc. Parameter ``notebook theme``
takes values from 0 to 5. See wxPython, demo for agw.aui for details.
- Added UI localization and support for Japanese configured test suites, valid for Robot Framework version 7.0.1 or higher.
- Added to Grid Editor, changing Zoom In/Out with ``Ctrl-Mouse Wheel`` and setting at Preferences.
- Added actions on columns of Grid Editor: Double-Click or Right Mouse Click, allows to edit the column name for Data
Driven or Templated; Left Mouse Click, selects the column cells.
- Added command line option, ``--settingspath``, to select a different configuration. For example, you can have different
colour settings or UI language.
- Added different settings file, according the actual Python executable, if not the original installed.
This allows different configurations, like, for example, in a virtual environment
- Added context option ``Open Containing Folder`` to test suites directories in Project Explorer.
- Added a setting for a specific file manager by editing the settings.cfg file. Add the string parameter ``file manager`` in the section ``[General]``.
- Added minimal support to have comment lines in Import settings. These are not supposed to be edited in Editor, and new lines are added at Text Editor.
- Added a selector for Tasks and Language to the New Project dialog. Still some problems: Tasks type changes to Tests,
localized sections only stay translated after Apply in Text Editor.
- Added UI localization prepared for all the languages from installed Robot Framework version 6.1, or
higher. Major translations are: Dutch, Portuguese and Brazilian Portuguese. Language is selected from
Tools->Preferences->General.
- Added support for language configured test suites, with installed Robot Framework version 6.1 or higher.
- Fields are shown in the language of the files in Grid Editor (will be configurable in future versions).
- Tooltips for the fields are always shown in English.
- Colorization for language configured files is working in Text Editor.

=== Fixed

- Fixed multiline variables in Variables section. In Text Editor they are separated by ... continuation marker.
In Grid Editor use | (pipe) to separate lines.
- Fixed keywords Find Usages in Grid Editor not finding certain values when using Gherkin.
- Fixed plugin Run Anything (Macros) not showing output and broken actions.
- Fixed headers and blank spacing in Templated tests
- Fixed removal of continuation marker in steps
- Fixed wrong continuation of long chains of keywords in Setups, Teardowns or Documentation
- Fixed New User Keyword dialog not allowing empty Arguments field

=== Changed

- Improved release packaging of RIDE, by using entry_points in setuptools configuration.
- Parsing of clipboard content to separate by cells in Grid Editor. NOTE: Need to Apply Changes in Text Editor to be effective.
- Improved selection of items from Tree in Text Editor. Now finds more items and selects whole line.
- Changed output in plugin Run Anything (Macros) to allow Zoom In/Out, and Copy content.

=== Removed

- Removed support for HTML file format (obsolete since Robot Framework 3.2)
- Removed support for old Python versions, 3.6 nd 3.7.

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.0.8.1.rst[2.0.8.1] - 2023-11-01

=== Added

- Added auto update check when development version is installed
- Added menu option ``Help->Check for Upgrade`` which allows to force update check and install development version
- Added ``Upgrade Now`` action to update dialog.
- Added Test Tags field (new, since Robot Framework 6.0) to Test Suites settings. This field will replace Default and
Force Tags settings, after Robot Framework 7.0
- Added content help pop-up on Text Editor by pressing ``Ctrl`` for text at cursor position or selected autocomplete list item
- Added Exclude option in context nenu for Test files, previously was only possible for Test Suites folders
- Added exclusion of monitoring filesystem changes for files and directories excluded in Preferences
- Added variables creation shortcuts (``Ctrl-1,2,5``) to fields Arguments in Grid Editor
- Added support for JSON variables, by using the installed Robot Framework import method

=== Fixed

- Fixed escaped spaces showing in Text Editor on commented cells
- Fixed resource files dissapearing from Project tree on Windows
- Fixed missing indication of link for User Keyword, when pressing ``Ctrl`` in Grid Editor
- Fixed exception when finding GREY color for excluded files and directories in Project Tree
- Colorization of Grid Editor cells after the continuation marker ``...`` and correct parsing of those lines
- Colorization of Grid Editor cells when contents is list or dictionary variables
- Validation of Grid Editor arguments types in keywords definitions. Now accepts ``@{}`` named-only marker
- Position of cursor in Text Editor auto-suggestions when line contains multibyte characters
- Drag and drop of variables defined with comments between resource files

=== Changed

- Improved keywords documentation search, by adding current dir to search
- Improved Move up/down, ``Alt-UpArrow``/``Alt-DownArrow`` in Text Editor, to have proper indentation and selection
- Improved **RIDE Log** and **Parser Log** windows to allow Zoom In/Out with ``Ctrl-Mouse Wheel``
- Hide continuation markers in Project Tree
- Improved content assistance in Text Editor by allowing to filter list as we type
- Improved file changes detection to only consider valid formats
- Improved keyword ``Find Usages`` to return more matches. Fails to find mixed spaces and ``_``
- In Grid Editor ``Ctrl-Shift-4`` now replaces escaped spaces ``\\ `` by spaces

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.0.7.rst[2.0.7] - 2023-08-13

=== Added

- Added indication of matching brackets, ``()``, ``{}``, ``[]``, in Text Editor
- Added context menu to RIDE tray icon. Options Show, Hide and Close
- Added sincronization with Project Explorer to navigate to selected item, Test Case, Keyword, Variable, in Text Editor
  Note: This feature is working fine in Fedora 38, but not on Windows and macOS.

=== Fixed

- Fixed non syncronized expanding/collapse of Settings panel in Grid Editor, on Linux
- Fixed not working the deletion of cells commented with ``\# `` in Grid Editor with ``Ctrl-Shift-D``
- Fixed empty line being always added to the Variables section in Text Editor
- Fixed wrong project reloading when file system changes detected, and other related problems
- Fixed control commands (``FOR``, ``IF``, ``TRY``, etc) being colorized as valid keywords when typed not in all caps in Grid Editor
- Fixed title of User Keyword in Grid Editor always showing ``Find Usages`` instead of the keyword name
- Fixed renaming keywords when they were arguments of ``Run Keywords`` in Setups and Teardowns

=== Changed

- Improve Text Editor auto-suggestions to keep libraries prefixes.

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.0.6.rst[2.0.6] - 2023-06-10

=== Added

- Added boolean parameter ``filter newlines`` to Grid Editor with default ``True``, to hide or show newlines in cells

=== Changed

- Changed ``tasks.py`` to test ``utest/application/test_app_main.py`` isolated from the other tests
- Improve auto-suggestions of keywords in Grid Editor by allowing to close suggestions list with keys ARROW_LEFT or ARROW_RIGHT
- Improve Text Editor auto-suggestions by using: selected text, text at left or at right of cursor

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.0.5.rst[2.0.5] - 2023-05-08

=== Added

- Added ``FOR`` scope markers (``IN``, ``IN RANGE``, ``IN ENUMERATE``, ``IN ZIP``) to auto-complete list
- Added support to read environment variable ``ROBOT_VERSION`` to apply some conditions.
- Added note on Test Timeout that **timeout message** is not supported since Robot v3.0.1
- Added the note, 'Colors will be active after next RIDE restart.' to the Preferences of Test Runner.

=== Changed

- Changed alias marker on library imports to consider variable ``ROBOT_VERSION``. If version is lower than 6.0, uses ``'WITH NAME'``, otherwise will use ``'AS'``

== Fixed

- Fixed auto-indent on block commands in Text Editor

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.0.3.rst[2.0.3] - 2023-04-16

=== Changed

- Allow to do auto-suggestions of keywords in Grid Editor without a shortcut, if you want to enable or disable this feature you can config in `Tools-> Preferences -> Grid Editor -> Enable auto suggestions`
- Made ``\\n`` visible when editing cells in Grid Editor (problematic in Windows)

== Fixed

- Fixed missing auto-enclosing when in Cell Editor in Linux
- Fixed RIDE will crash when using third party input method in Mac OS
- Fixed missing color definition for keyword call in Text Editor
- Fixed clearing or emptying fixtures (Setups, Teardowns), now removes headers and synchronizes Text Editor
- Fixed selection and persistance of colors in File Explorer and Project Tree panels
- Fixed not using defined color for help and HTML content
- Fixed missing newlines in sections separation


== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.0.rst[2.0] - 2023-03-01

=== Added
  (2.0rc1 - 2023-02-26)
- Minimal support to accept `*** Comments ***` sections (unfinished code)
- Added insert and delete cells to Text Editor, by using ``Ctrl-Shift-I`` and ``Ctrl-Shift-D``
- Added move up and move down rows to Text Editor, by using ``Alt-Up`` and ``Alt-Down``
- Added insert and delete rows to Text Editor, by using ``Ctrl-I`` and ``Ctrl-D``
  (2.0b3 - 2023-01-15)
- Added swap row up, by using ``Ctrl-T``
- Added commenting/uncommenting of content with ``\# ``, by using ``Ctrl-Shift-3`` and ``Ctrl-Shift-4``
- Added support for editing .robot and .resource files with content before sections
  (2.0b2 - 2022-09-05)
- Added menu entry at Help -> Offline Change Log to view this file on disk
- Added skipped tests counter and corresponding colored icon on Project tree
- Added color processing in console log, when using ``-C`` or ``--consolecolors``
- Added minimal support to open and edit resource files in Grid Editor
- Added multiline comment and uncomment in Text Editor
- Added support for variables recognition in FOR and Set (\*) Variable, where (\*) means Test, Task, Global, Suite, etc.
- Added documentation and syntax color for IF, ELSE, ELSE IF, WHILE, TRY, EXCEPT, BREAK, CONTINUE
- Added indentation for nested FOR loops
- Added a Reformat option when saving files on Preferences -> Saving
- Added colorization in Text Editor for Tasks
- Added a dialog to Load or Save settings to .cfg files on Preferences -> General, Grid Editor, Text Editor and Test Runner
- Added perspectives' persistence for Notebook panels, Edit, Text Editor and Run
- Added General settings to Preferences, to change Font Size and Face, and colours
- Added background colour globally on panels and dialogs
- Added on Run tab a button to open the Logs Directory
- Added on Run tab a group of elements to define Output Directory, Log and Report filenames with suite names or timestamps, and possibility to keep Console and Message logs
- Added Python 3.8 unit test support in travis CI
- Added menu option to ``Move Up`` and ``Move Down`` variables in Tree
- Added menu option to ``Sort Variables`` in resources from Tree 
- Added menu option to ``Sort Tests`` and ``Sort Variables`` in suites from Tree
- Added menu icons (visible on most operating systems)
- Added RIDE application dock icon on MacOS
- Added selection of keyword suggestion with TAB key on Text Editor
- Added RIDE.app to install in Applications on MacOS
    * Also creates a symbolic link to RIDE.app on user's Desktop
    * Users will need to edit ``/etc/paths`` to include paths for ``robot`` and other commands like ``chromedriver``, etc
- Added an Open External File menu option, to open file in Code Editor
- Added multiline view in Grid Editor
    * When editing, ``\\n`` will be converted to newline, ``\\\\n`` will remain as is.
    * When editing, ``\\ `` will be converted to whitespace.
    * When editing, Alt-Enter is the same as ``\n``, converted immediately.
    * When editing, Ctrl-Up and Ctrl-Down move cursor to start and end of multiline respectively.
    * When editing, Ctrl-Home and Ctrl-End move cursor to start and end of cell content respectively.
- Added Del key to clear Grid Editor cell content when in navigation mode (clear like doing Ctrl-X)
  (2.0b1 - 2020-07-26)
- Added CHANGELOG.adoc
- Added ignoring log.html and report.html on reporting HTML test suites
- Added conditions for wxPython versions equal or higher than 4.1.0
- Added indent and de-indent with TAB for blocks of text
- Added auto indent in Text Editor
- Added enclosing text in Text Editor or selected text with certain symbols
- Added enclosing text in Grid Editor or selected text with certain symbols
- Added 8s timer to shortcut creation dialog on install
- Added process memory limit on Messages Log

=== Removed
  (2.0b2 - 2022-09-05)
- Removed ``robotframeworklexer`` dependency and local copy
- Removed alignment flag on grid cell JSON Editor (Ctrl-Shift-J)
- Removed moving to keyword/variable definition when doing Double-Click in grid cell
  (2.0b1 - 2020-07-26)
- Python 2.7 support
- wxPython/wxPhoenix version conditioning

=== Changed
  (2.0b3 - 2023-01-15)
- Hiding items in Test Suites explorer with names starting with #
- Disabled the Close button on the Test Suites explorer
  This was causing not being possible to restore it, unless editing the settings.cfg file.
  Other reason was to prevent user to closing it, after detaching the panel, and re-attaching,
  which has a bug making the Tree not visible.
  (2.0b2 - 2022-09-05)
- Unit tests to use ``pytest`` and removed ``nose`` dependency. Support for Python 3.10 at unit test level.
- Prevent expanding Tests and change selection on Project tree (when right-clicking)
- Improved Text Edit processing of # comments
- Improved filesystem changes detection to be less reactive
- Changed Manage Plugins to be a dialog panel instead of being a notebook tab
- Added more valid file extensions to Open Test Suite
- Changed minimum number of rows and columns, because blank cells would not have correct colour
- The Arguments, Tests filters (include/exclude), Console and Message logs are now in Expandable/Collapsable groups
- Modified robot passed and failed icons to be easier to differentiate
- When searching in Text Editor by using Ctrl-G the search is done from the begining of text
- On MacOS, grid cell will not lose focus anymore when mouse is moving outside of the cell's boundary
- Changed moving to keyword definition to be with Ctrl-Click (keep Ctrl-B action)
    * To edit cell use F2 or Double-Click
- Changed Enter button in navigation mode to start editing cell, and to move to right cell when in edit mode
- Performance improvements for loading large test suites
  (2.0b1 - 2020-07-26)
- Improved filesystem changes detection, with a confirmation dialog to reload workspace
- Changed dependency on wx.Window on tree panel
- Improved error and removal of old log files
- Changed icon background to white
- Made Project Tree and File Explorer panels, Plugins.
- wx.NewId() to wx.NewIdRef()
- Separated AppendText for Messages Log

=== Fixed
  (2.0rc1 - 2023-02-26)
- Fixed blank Grid Editor at keywords with steps commented with ``\# ``, by using ``Ctrl-Shift-3 on Text Editor
  (2.0b3 - 2023-01-15)
. Fixed low performance when opening large projects
- Fixed comment and uncomment in Grid Editor when cells contain more than one variables assignement
- Fixed console log stopping to output certain characters, like chinese and latin
  (2.0b2 - 2022-09-05)
- Fixed missing menu icons on Linux (was working on Windows)
- Fixed removal of animation in Project tree when test run is interrupted
- Fixed console log width to fit visible area, depending on font size
- Fixed not possible to use filenames/paths with spaces in TestRunner arguments. Use double quotes for space separated values,
- Fixed error preventing to open old format, HTML test suites:
    * Yes, we are at RF 5.0.1, but still can open HTML test suites (and then Change to .robot)
- Fixed broken sorting Tests and Variables in Project tree (right-click menu)
- Fixed JSON in cell editor not saving nor validating JSON
- Fixed TestRunner crash when test use SKIP keyword
- Fixed broken pipe errors when using ``--loglevel  DEBUG:INFO``
- Fixed various output console encoding issue in different platforms
- Fixed errors when importing libraries with keyword only arguments (i.e. robotframework-requestschecker)
- Fixed sys.stderr is None errors if RIDE is launched by pythonw.exe
- Fixed RIDE cannot close properly when Screenshot library is loaded
- Fixed incorrect title in manage plugin settings
- Fixed search in Text Editor with wxPython 4.1.0
- Fixed resource file will disappear after saving from Text Editor
- Fixed duplicated resource file/folder in tree nodes
- Fixed Ctrl-Space causing entire column to be selected in Grid Editor
- Fixed Del key was clearing cell content on Grid Editor
- Fixed ``${CURDIR}`` & ``${EXECDIR}`` cannot be recognized in import settings
- Fixed memory leak when reloading workspace
- Fixed RIDE desktop shortcut creation when installing by Administrator on Windows
- Fixed location of icon on Linux RIDE.desktop
- Fixed incorrect app windows size configuration after maximizing
- Fixed errors raised when adding external resources
- Fixed progress dialog is missing when adding external resources
- Fixed missing keyword suggestions on Resource files in Text Editor
- Fixed Del key in Text Editor, was not deleting text
- Fixed duplicated but empty Text Editor tab when Text Editor is the only active editor Plugin
- Fixed case will be selected invisibly after being modified from Text Editor
- Fixed some of log messages log level are incorrect sometimes
- Fixed some of log messages are missing sometimes
- Fixed smart quotes replace in Grid Editor on MacOS
- Fixed incorrect arguments parsing when launching RIDE with command ``python -m robotide.\\__init__``
- Fixed RIDE startup crash when Tree or File Explorer plugins use opened=False setting
- Fixed error occurring when deleting test cases on Tree
  (2.0b1 - 2020-07-26)
- Fixed editing cells in Grid Editor on wxPython 4.1
- Fixed not saving file after deleting text in Text Editor
- Fixed elements sizing on Preferences panel
- Fixed tree selection, because of wrong variable name
- Fixed encodings on Windows
- Fixed bugs on Grid Editor
- Fixed error message on RIDE Log about missing clear_all
- Fixed tree nodes problems
- Fixed severe RIDE freeze when selecting all test cases in large test suites
- Fixed activation of RIDE Log plugin
- Fixed missing keywords documentation for dynamic libraries (i.e. SeleniumLibrary 4.4.0)
- Fixed not possible to create new project
- Fixed missing Save menu option
- Fixed sounding a beep and no selection when pressing down arrow in keywords help list
- Fixed output log showing garbled code when the name of the test case contains Chinese
- Fixed default arguments help
- Fixed crash when deleting tags
- Fixed cursor position when creating variables with CTRL-1,2,5
- Fixed pressing F2 in Grid Editor on MacOS started editor on Project Tree
- Fixed reprocessing of %date% %time% variables on Windows
- Fixed not editing cells with F2 and keeping focus
- Fixed keywords arguments help
- Fixed Python 3.8 incompatibility
- Fixed showing Resource files with extension .resource in Tree when not used
- Fixed RIDE not starting
- Fixed errors at start due to setlocale()
- Fixed Settings editor
- Fixed blank Edit screen
- Fixed Runner arguments parsing
- Fixed Runner Log window Chinese and Latin encoding chars on Windows


== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.0rc1.rst[2.0rc1] - 2023-02-26

=== Added

- Minimal support to accept `*** Comments ***` sections (unfinished code)
- Added insert and delete cells to Text Editor, by using ``Ctrl-Shift-I`` and ``Ctrl-Shift-D``
- Added move up and move down rows to Text Editor, by using ``Alt-Up`` and ``Alt-Down``
- Added insert and delete rows to Text Editor, by using ``Ctrl-I`` and ``Ctrl-D``

=== Removed

=== Changed

=== Fixed

- Fixed blank Grid Editor at keywords with steps commented with ``\# ``, by using ``Ctrl-Shift-3 on Text Editor

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.0b3.rst[2.0b3] - 2023-01-15

=== Added

- Added swap row up, by using ``Ctrl-T``
- Added commenting/uncommenting of content with ``\# ``, by using ``Ctrl-Shift-3`` and ``Ctrl-Shift-4``
- Added support for editing .robot and .resource files with content before sections

=== Removed

- None

=== Changed

- Hiding items in Test Suites explorer with names starting with #
- Disabled the Close button on the Test Suites explorer
  This was causing not being possible to restore it, unless editing the settings.cfg file.
  Other reason was to prevent user to closing it, after detaching the panel, and re-attaching,
  which has a bug making the Tree not visible.

=== Fixed

. Fixed low performance when opening large projects
- Fixed comment and uncomment in Grid Editor when cells contain more than one variables assignement
- Fixed console log stopping to output certain characters, like chinese and latin

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.0b2.rst[2.0b2] - 2022-09-05

=== Added

- Added menu entry at Help -> Offline Change Log to view this file on disk
- Added skipped tests counter and corresponding colored icon on Project tree
- Added color processing in console log, when using ``-C`` or ``--consolecolors``
- Added minimal support to open and edit resource files in Grid Editor
- Added multiline comment and uncomment in Text Editor
- Added support for variables recognition in FOR and Set (\*) Variable, where (\*) means Test, Task, Global, Suite, etc.
- Added documentation and syntax color for IF, ELSE, ELSE IF, WHILE, TRY, EXCEPT, BREAK, CONTINUE
- Added indentation for nested FOR loops
- Added a Reformat option when saving files on Preferences -> Saving
- Added colorization in Text Editor for Tasks
- Added a dialog to Load or Save settings to .cfg files on Preferences -> General, Grid Editor, Text Editor and Test Runner
- Added perspectives' persistence for Notebook panels, Edit, Text Editor and Run
- Added General settings to Preferences, to change Font Size and Face, and colours
- Added background colour globally on panels and dialogs
- Added on Run tab a button to open the Logs Directory
- Added on Run tab a group of elements to define Output Directory, Log and Report filenames with suite names or timestamps, and possibility to keep Console and Message logs
- Added Python 3.8 unit test support in travis CI
- Added menu option to ``Move Up`` and ``Move Down`` variables in Tree
- Added menu option to ``Sort Variables`` in resources from Tree 
- Added menu option to ``Sort Tests`` and ``Sort Variables`` in suites from Tree
- Added menu icons (visible on most operating systems)
- Added RIDE application dock icon on MacOS
- Added selection of keyword suggestion with TAB key on Text Editor
- Added RIDE.app to install in Applications on MacOS
    * Also creates a symbolic link to RIDE.app on user's Desktop
    * Users will need to edit ``/etc/paths`` to include paths for ``robot`` and other commands like ``chromedriver``, etc
- Added an Open External File menu option, to open file in Code Editor
- Added multiline view in Grid Editor
    * When editing, ``\n`` will be converted to newline, ``\\n`` will remain as is.
    * When editing, ``\ `` will be converted to whitespace.
    * When editing, Alt-Enter is the same as ``\n``, converted immediately.
    * When editing, Ctrl-Up and Ctrl-Down move cursor to start and end of multiline respectively.
    * When editing, Ctrl-Home and Ctrl-End move cursor to start and end of cell content respectively.
- Added Del key to clear Grid Editor cell content when in navigation mode (clear like doing Ctrl-X)

=== Removed

- Removed ``robotframeworklexer`` dependency and local copy
- Removed alignment flag on grid cell JSON Editor (Ctrl-Shift-J)
- Removed moving to keyword/variable definition when doing Double-Click in grid cell

=== Changed

- Unit tests to use ``pytest`` and removed ``nose`` dependency. Support for Python 3.10 at unit test level.
- Prevent expanding Tests and change selection on Project tree (when right-clicking)
- Improved Text Edit processing of # comments
- Improved filesystem changes detection to be less reactive
- Changed Manage Plugins to be a dialog panel instead of being a notebook tab
- Added more valid file extensions to Open Test Suite
- Changed minimum number of rows and columns, because blank cells would not have correct colour
- The Arguments, Tests filters (include/exclude), Console and Message logs are now in Expandable/Collapsable groups
- Modified robot passed and failed icons to be easier to differentiate
- When searching in Text Editor by using Ctrl-G the search is done from the begining of text
- On MacOS, grid cell will not lose focus anymore when mouse is moving outside of the cell's boundary
- Changed moving to keyword definition to be with Ctrl-Click (keep Ctrl-B action)
    * To edit cell use F2 or Double-Click
- Changed Enter button in navigation mode to start editing cell, and to move to right cell when in edit mode
- Performance improvements for loading large test suites


=== Fixed

- Fixed missing menu icons on Linux (was working on Windows)
- Fixed removal of animation in Project tree when test run is interrupted
- Fixed console log width to fit visible area, depending on font size
- Fixed not possible to use filenames/paths with spaces in TestRunner arguments. Use double quotes for space separated values,
- Fixed error preventing to open old format, HTML test suites:
    * Yes, we are at RF 5.0.1, but still can open HTML test suites (and then Change to .robot)
- Fixed broken sorting Tests and Variables in Project tree (right-click menu)
- Fixed JSON in cell editor not saving nor validating JSON
- Fixed TestRunner crash when test use SKIP keyword
- Fixed broken pipe errors when using ``--loglevel  DEBUG:INFO``
- Fixed various output console encoding issue in different platforms
- Fixed errors when importing libraries with keyword only arguments (i.e. robotframework-requestschecker)
- Fixed sys.stderr is None errors if RIDE is launched by pythonw.exe
- Fixed RIDE cannot close properly when Screenshot library is loaded
- Fixed incorrect title in manage plugin settings
- Fixed search in Text Editor with wxPython 4.1.0
- Fixed resource file will disappear after saving from Text Editor
- Fixed duplicated resource file/folder in tree nodes
- Fixed Ctrl-Space causing entire column to be selected in Grid Editor
- Fixed Del key was clearing cell content on Grid Editor
- Fixed ``${CURDIR}`` & ``${EXECDIR}`` cannot be recognized in import settings
- Fixed memory leak when reloading workspace
- Fixed RIDE desktop shortcut creation when installing by Administrator on Windows
- Fixed location of icon on Linux RIDE.desktop
- Fixed incorrect app windows size configuration after maximizing
- Fixed errors raised when adding external resources
- Fixed progress dialog is missing when adding external resources
- Fixed missing keyword suggestions on Resource files in Text Editor
- Fixed Del key in Text Editor, was not deleting text
- Fixed duplicated but empty Text Editor tab when Text Editor is the only active editor Plugin
- Fixed case will be selected invisibly after being modified from Text Editor
- Fixed some of log messages log level are incorrect sometimes
- Fixed some of log messages are missing sometimes
- Fixed smart quotes replace in Grid Editor on MacOS
- Fixed incorrect arguments parsing when launching RIDE with command ``python -m robotide.\\__init__``
- Fixed RIDE startup crash when Tree or File Explorer plugins use opened=False setting
- Fixed error occurring when deleting test cases on Tree

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-2.0b1.rst[2.0b1] - 2020-07-26

=== Added

- Added CHANGELOG.adoc
- Added ignoring log.html and report.html on reporting HTML test suites
- Added conditions for wxPython versions equal or higher than 4.1.0
- Added indent and de-indent with TAB for blocks of text
- Added auto indent in Text Editor
- Added enclosing text in Text Editor or selected text with certain symbols
- Added enclosing text in Grid Editor or selected text with certain symbols
- Added 8s timer to shortcut creation dialog on install
- Added process memory limit on Messages Log

=== Removed

- Python 2.7 support
- wxPython/wxPhoenix version conditioning

=== Changed

- Improved filesystem changes detection, with a confirmation dialog to reload workspace
- Changed dependency on wx.Window on tree panel
- Improved error and removal of old log files
- Changed icon background to white
- Made Project Tree and File Explorer panels, Plugins.
- wx.NewId() to wx.NewIdRef()
- Separated AppendText for Messages Log

=== Fixed

- Fixed editing cells in Grid Editor on wxPython 4.1
- Fixed not saving file after deleting text in Text Editor
- Fixed elements sizing on Preferences panel
- Fixed tree selection, because of wrong variable name
- Fixed encodings on Windows
- Fixed bugs on Grid Editor
- Fixed error message on RIDE Log about missing clear_all
- Fixed tree nodes problems
- Fixed severe RIDE freeze when selecting all test cases in large test suites
- Fixed activation of RIDE Log plugin
- Fixed missing keywords documentation for dynamic libraries (i.e. SeleniumLibrary 4.4.0)
- Fixed not possible to create new project
- Fixed missing Save menu option
- Fixed sounding a beep and no selection when pressing down arrow in keywords help list
- Fixed output log showing garbled code when the name of the test case contains Chinese
- Fixed default arguments help
- Fixed crash when deleting tags
- Fixed cursor position when creating variables with CTRL-1,2,5
- Fixed pressing F2 in Grid Editor on MacOS started editor on Project Tree
- Fixed reprocessing of %date% %time% variables on Windows
- Fixed not editing cells with F2 and keeping focus
- Fixed keywords arguments help
- Fixed Python 3.8 incompatibility
- Fixed showing Resource files with extension .resource in Tree when not used
- Fixed RIDE not starting
- Fixed errors at start due to setlocale()
- Fixed Settings editor
- Fixed blank Edit screen
- Fixed Runner arguments parsing
- Fixed Runner Log window Chinese and Latin encoding chars on Windows

== https://github.com/robotframework/RIDE/blob/master/doc/releasenotes/ride-1.7.4.2.rst[1.7.4.2] - 2020-01-20

=== Added

- wxPython version locked up to 4.0.7.post2.

=== Removed

- None

=== Changed

- None

=== Fixed

- None

